Imports System.IO
Imports System.Reflection
Imports System.Resources

Public Class Form1
    ' The assembly's information.
    Private m_Assembly As [Assembly] = Nothing

    ' Type objects for the assembly's resources.
    Private m_Resources As Type = Nothing

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim file_info As New FileInfo(Application.StartupPath & _
            "..\..\..\..\ResourcesLib\bin\Debug\ResourcesLib.dll")

        txtPath.Text = file_info.FullName
        txtFile.Location = panImage.Location
        txtFile.Size = panImage.Size
    End Sub

    ' Get information about the assembly's resources.
    Private Sub btnGetResourceInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetResourceInfo.Click
        ' Get the assembly's information.
        m_Assembly = [Assembly].LoadFrom(txtPath.Text)
        lstResources.Enabled = True
    End Sub

    ' Display the selected resource.
    Private Sub lstResources_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstResources.SelectedIndexChanged
        If lstResources.SelectedItem Is Nothing Then Exit Sub

        panImage.Visible = False
        txtFile.Visible = False

        ' Make a resource manager.
        Dim resource_manager As ResourceManager = _
            New ResourceManager("ResourcesLib.Resources", m_Assembly)

        ' Get the resource.
        Dim resource_name As String = lstResources.SelectedItem.ToString()
        If resource_name = "ringin" Then
            My.Computer.Audio.Play(resource_manager.GetStream(resource_name), AudioPlayMode.WaitToComplete)
        Else
            Dim obj As Object = resource_manager.GetObject(resource_name)
            If TypeOf obj Is Bitmap Then
                picImage.Image = DirectCast(obj, Bitmap)
                panImage.Visible = True
            ElseIf TypeOf obj Is String Then
                txtFile.Text = DirectCast(obj, String)
                txtFile.Visible = True
            Else
                MessageBox.Show("Unknown resource type " & TypeName(obj), _
                    "Unknown Resource Type", _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    ' Let the user browse for an assembly.
    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click
        If dlgSelectAssembly.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            txtPath.Text = dlgSelectAssembly.FileName
        End If
    End Sub
End Class
