Imports System.Reflection
Imports System.Drawing.Drawing2D

Public Class Form1
    Private Const XMIN As Integer = 10
    Private Const SAMPLE_WID As Integer = 100
    Private Const SAMPLE_HGT As Integer = 100
    Private Const X_MARGIN As Integer = 10
    Private Const Y_MARGIN As Integer = 40

    ' Prepare for Paint events.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.ResizeRedraw Or _
            ControlStyles.OptimizedDoubleBuffer, _
            True)
        Me.UpdateStyles()

        Me.ClientSize = New Size( _
            2 * XMIN + 3 * SAMPLE_WID + 2 * X_MARGIN, _
            4 * XMIN + 2 * SAMPLE_HGT + 1 * Y_MARGIN)
    End Sub

    ' Display dash samples.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)
        Dim x As Integer = XMIN
        Dim y As Integer = XMIN

        ' Enumerate the Dash styles.
        Dim dash_style_type As Type = GetType(DashStyle)

        Dim field_infos() As FieldInfo = dash_style_type.GetFields()
        For Each field_info As FieldInfo In field_infos
            ' See if this is a static (Shared) property.
            ' We only want the Shared properties such as DashDot
            ' and not the instance properties such as value__.
            If field_info.IsStatic Then
                ' Get this style.
                Dim style_obj As Object = field_info.GetValue(Nothing)
                Dim dash_style As DashStyle = DirectCast(style_obj, DashStyle)

                ' Make the pen and draw the sample.
                Using the_pen As New Pen(Color.Blue, 5)
                    the_pen.DashStyle = dash_style
                    DrawSample(e.Graphics, x, y, the_pen, field_info.Name)
                End Using
            End If
        Next field_info
    End Sub

    ' Draw the sample and move (x, y) to a new position.
    Private Sub DrawSample(ByVal gr As Graphics, ByRef x As Integer, ByRef y As Integer, ByVal the_pen As Pen, ByVal style_name As String)
        ' Draw the sample.
        gr.DrawRectangle(the_pen, x, y, SAMPLE_WID, SAMPLE_HGT)

        ' Draw the style's name.
        Dim string_format As New StringFormat()
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Near
        gr.DrawString(style_name, Me.Font, Brushes.Blue, _
            x + SAMPLE_WID \ 2, y + SAMPLE_HGT + 10, string_format)

        ' Update x and y.
        x += SAMPLE_WID + X_MARGIN
        If x + SAMPLE_WID > Me.ClientSize.Width Then
            x = XMIN
            y += SAMPLE_HGT + Y_MARGIN
        End If
    End Sub
End Class
