Imports System.Reflection
Imports System.Collections.Generic

Public Class Form1
    Private Const XMIN As Integer = 10
    Private Const ICON_WID As Integer = 80
    Private Const ICON_HGT As Integer = 80

    Private m_Icons As New List(Of Icon)
    Private m_IconNames As New List(Of String)

    ' Load the system icons.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Load the system icons.
        Dim system_icon_type As Type = GetType(SystemIcons)
        Dim property_infos() As PropertyInfo = system_icon_type.GetProperties()
        For Each property_info As PropertyInfo In property_infos
            ' Save the icon and its name.
            Dim icon_obj As Object = property_info.GetValue(Nothing, Nothing)
            m_Icons.Add(DirectCast(icon_obj, Icon))
            m_IconNames.Add(property_info.Name)
        Next property_info

        ' Prepare for Paint events.
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.ResizeRedraw Or _
            ControlStyles.OptimizedDoubleBuffer, _
            True)
        Me.UpdateStyles()
        Me.ClientSize = New Size(3 * ICON_WID + 2 * XMIN, 3 * ICON_HGT + 2 * XMIN)
    End Sub

    ' Display the icons.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)
        Dim x As Integer = XMIN
        Dim y As Integer = XMIN
        For i As Integer = 0 To m_Icons.Count - 1
            DrawIcon(e.Graphics, x, y, m_Icons(i), m_IconNames(i))
        Next i
    End Sub

    ' Draw the sample and move (x, y) to a new position.
    Private Sub DrawIcon(ByVal gr As Graphics, ByRef x As Integer, ByRef y As Integer, ByVal the_icon As Icon, ByVal icon_name As String)
        ' Draw the icon.
        Dim rect As New Rectangle( _
            x + (ICON_WID - the_icon.Width) \ 2, _
            y + (ICON_HGT - the_icon.Height) \ 2, _
            the_icon.Width, the_icon.Height)
        gr.DrawIconUnstretched(the_icon, rect)

        ' Draw the icon's name.
        Dim string_format As New StringFormat()
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Far
        gr.DrawString(icon_name, Me.Font, Brushes.Blue, _
            x + ICON_WID \ 2, y + ICON_HGT, string_format)

        gr.DrawRectangle(Pens.Red, x, y, ICON_WID, ICON_HGT)

        ' Update x and y.
        x += ICON_WID
        If x + ICON_WID > Me.ClientSize.Width Then
            x = XMIN
            y += ICON_HGT
        End If
    End Sub
End Class
